--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -1,9 +1,7 @@
 PROJECT(ponyprog)
 
 # Configure CMake ...
-CMAKE_MINIMUM_REQUIRED(VERSION 2.8 FATAL_ERROR)
-CMAKE_POLICY(SET CMP0003 OLD)
-CMAKE_POLICY(SET CMP0015 OLD)
+CMAKE_MINIMUM_REQUIRED(VERSION 2.8.12 FATAL_ERROR)
 
 # set the Qt version to 4 or 5
 OPTION (USE_QT5 "Using of Qt5 version for compiling" ON)
@@ -52,13 +50,7 @@
 OPTION (USE_PROFILER "Include in binary file profiling information" OFF)
 
 
-
-IF(${USE_DEBUGGER})
-  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS_DEBUG} -Wall")
-ELSE()
-  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS_RELEASE} -Wall")
-ENDIF()
-
+ADD_COMPILE_OPTIONS("-Wall")
 MESSAGE(STATUS "CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS}")
 
 INCLUDE(CheckIncludeFile)
@@ -202,7 +194,6 @@
 SET ( UI_HEADERS_DIR temp )
 SET ( UI_SOURCES_DIR temp )
 
-ADD_SUBDIRECTORY(qhexedit2/src)
 ADD_SUBDIRECTORY(SrcPony)
 
 INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/qhexedit2/src/ ${CMAKE_CURRENT_SOURCE_DIR}/SrcPony/ )
@@ -265,6 +256,8 @@
   MESSAGE(STATUS "QT LIBRARIES: ${QT_LIBRARIES} ${Qt5Widgets_LIBRARIES} ${Qt5Multimedia_LIBRARIES} ${Qt5PrintSupport_LIBRARIES} ${Qt5Core_LIBRARIES}")
 ENDIF()
 
+TARGET_LINK_LIBRARIES(${CMAKE_PROJECT_NAME} qhexedit)
+
 ADD_CUSTOM_TARGET (tags
     COMMAND  ctags -R -f tags ${CMAKE_SOURCE_DIR}/SrcPony
     WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
--- a/distribution/posix/CMakeLists.txt
+++ b/distribution/posix/CMakeLists.txt
@@ -5,6 +5,8 @@
 SET(CPACK_INSTALL_PREFIX "/usr") 
 SET(CPACK_PACKAGE_INSTALL_DIRECTORY "/usr")
 
+INCLUDE(GNUInstallDirs)
+
 MESSAGE("CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX}")
 
 # SET( CPACK_PACKAGE_GROUP "${PONYPROG_CPACK_PACKAGE_GROUP}" )
@@ -12,46 +14,40 @@
 SET( CPACK_PACKAGE_SHLIBDEPS "${PONYPROG_CPACK_PACKAGE_SHLIBDEPS}" )
 # SET( CPACK_PACKAGE_DEPENDS "${PONYPROG_CPACK_PACKAGE_DEPENDS}" )
 
-INSTALL(PROGRAMS "${CURRENT_BUILD_DIR}/ponyprog" 
-        DESTINATION "bin/" 
-        COMPONENT "application" 
-        PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ
+INSTALL(PROGRAMS "${CURRENT_BUILD_DIR}/ponyprog"
+        DESTINATION "${CMAKE_INSTALL_BINDIR}"
+        COMPONENT "application"
         )
 
-INSTALL(DIRECTORY "${PROJECT_SOURCE_DIR}/icons/"    
-        DESTINATION "share/icons/" 
-        COMPONENT "application" 
-        DIRECTORY_PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ 
+INSTALL(DIRECTORY "${PROJECT_SOURCE_DIR}/icons/"
+        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons"
+        COMPONENT "application"
         FILES_MATCHING PATTERN "*.png"
         )
 
-INSTALL(DIRECTORY "${PROJECT_SOURCE_DIR}/lang/" 
-        DESTINATION "share/ponyprog/lang/" 
-        COMPONENT "lang files" 
-        DIRECTORY_PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ 
+INSTALL(DIRECTORY "${PROJECT_SOURCE_DIR}/lang/"
+        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/ponyprog/lang"
+        COMPONENT "lang files"
         FILES_MATCHING PATTERN "*.utf"
-        ) 
+        )
 
-INSTALL(DIRECTORY "${PROJECT_SOURCE_DIR}/distribution/innosetup/" 
-        DESTINATION "share/doc/ponyprog/" 
-        COMPONENT "help files" 
-        DIRECTORY_PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ 
+INSTALL(DIRECTORY "${PROJECT_SOURCE_DIR}/distribution/innosetup/"
+        DESTINATION "${CMAKE_INSTALL_DOCDIR}"
+        COMPONENT "help files"
         FILES_MATCHING PATTERN "*.jpg" PATTERN "*.html"
-        ) 
+        )
 
-INSTALL(FILES "${PROJECT_SOURCE_DIR}/copyright" 
-        DESTINATION "share/doc/ponyprog/" 
-        COMPONENT "application" 
-        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ
-        ) 
+INSTALL(FILES "${PROJECT_SOURCE_DIR}/copyright"
+        DESTINATION "${CMAKE_INSTALL_DOCDIR}"
+        COMPONENT "application"
+        )
 # MESSAGE("PROJECT_SOURCE_DIR ${PROJECT_SOURCE_DIR}")
 
 INSTALL(FILES "${PROJECT_SOURCE_DIR}/desktop/ponyprog.desktop"
-        DESTINATION "share/applications/" 
-        COMPONENT "application" 
-        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ
+        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/applications/"
+        COMPONENT "application"
         )
-        
+
 SET(CPACK_INSTALL_CMAKE_PROJECTS "${PONYPROG_CPACK_INSTALL_CMAKE_PROJECTS}")
 
 SET(PONYPROG_PACKAGE_DIRECTORY "${CURRENT_BUILD_DIR}")
